diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
index f2ca1c8a2..a5a6a24dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorFont.java
@@ -25,6 +25,7 @@ public class TessellatorFont {
 
     private final int vao;
     private final int vbo;
+    private final int vboMesh;
 
     private final @NotNull String name;
     private ByteBuffer data;
@@ -37,24 +38,39 @@ public class TessellatorFont {
 
         this.vao = GL41.glGenVertexArrays();
         this.vbo = GL41.glGenBuffers();
+        this.vboMesh = GL41.glGenBuffers();
 
         GL41.glBindVertexArray(this.vao);
+
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vboMesh);
+        float[] mesh = {
+            0,  1,
+            1,  1,
+            0,  0,
+            1,  0,
+        };
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, mesh, GL41.GL_STATIC_DRAW);
+        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, 0, 0);
+
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
-        int vertSize = 2 * Float.BYTES + 9;
-        int offset = 0;
-        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, vertSize, offset); offset += Float.BYTES * 2; // Pos XY
-        GL41.glVertexAttribPointer(1, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // Width Height
-        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertSize, offset); offset += 4; // Color
-        GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 2; // UV
-        GL41.glVertexAttribPointer(4, 1, GL41.GL_UNSIGNED_BYTE, false, vertSize, offset); offset += 1; // Config
-        GL41.glVertexAttrib1f(5, LightIndexHelper.lightIndex2i(15, 15));
+        setAttribOffset(0);
+        GL41.glVertexAttrib1f(6, LightIndexHelper.lightIndex2i(15, 15));
 
         GL41.glEnableVertexAttribArray(0);
         GL41.glEnableVertexAttribArray(1);
         GL41.glEnableVertexAttribArray(2);
         GL41.glEnableVertexAttribArray(3);
         GL41.glEnableVertexAttribArray(4);
+        GL41.glEnableVertexAttribArray(5);
+
+        GL41.glVertexAttribDivisor(0, 0); // Vertices, always reuse the same 4 vertices
+        GL41.glVertexAttribDivisor(1, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(2, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(3, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(4, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(5, 1); // Data, one per quad
+
         GL41.glBindVertexArray(0);
     }
 
@@ -122,12 +138,14 @@ public class TessellatorFont {
             int start = this.renderRanges.getInt(i + 1);
             int count = this.renderRanges.getInt(i + 2);
             GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
-            GL41.glDrawArrays(DrawMode.POINTS.cap, start, count);
+            setAttribOffset(start);
+            GL41.glDrawArraysInstanced(DrawMode.TRIANGLE_STRIP.cap, 0, 4, count);
         }
 
         if (this.texture != -1) {
             GL41.glBindTexture(GL41.GL_TEXTURE_2D, this.texture);
-            GL41.glDrawArrays(DrawMode.POINTS.cap, this.start, this.vertexCount);
+            setAttribOffset(this.start);
+            GL41.glDrawArraysInstanced(DrawMode.TRIANGLE_STRIP.cap, 0, 4, this.vertexCount);
         }
 
         GL41.glBindVertexArray(0);
@@ -216,6 +234,16 @@ public class TessellatorFont {
         }
     }
 
+    private void setAttribOffset(int offset) {
+        int vertSize = 2 * Float.BYTES + 9;
+        int _offset = offset * vertSize;
+        GL41.glVertexAttribPointer(1, 2, GL41.GL_FLOAT, false, vertSize, _offset); _offset += Float.BYTES * 2; // Pos XY
+        GL41.glVertexAttribPointer(2, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, _offset); _offset += 2; // Width Height
+        GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true, vertSize, _offset); _offset += 4; // Color
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false, vertSize, _offset); _offset += 2; // UV
+        GL41.glVertexAttribPointer(5, 1, GL41.GL_UNSIGNED_BYTE, false, vertSize, _offset); _offset += 1; // Config
+    }
+
     public record FontRenderBuffer(int vao, int vbo, int[] metadata) {
         public void delete() {
             GL41.glDeleteVertexArrays(this.vao);
@@ -236,7 +264,7 @@ public class TessellatorFont {
                 int start = this.metadata[i + 1];
                 int count = this.metadata[i + 2];
                 GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
-                GL41.glDrawArrays(DrawMode.POINTS.cap, start, count);
+                GL41.glDrawArraysInstanced(DrawMode.TRIANGLE_STRIP.cap, start, 4, count);
             }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
index 1f5dd4dba..6f7866d07 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
@@ -22,6 +22,7 @@ public class TessellatorParticleShader implements TessellatorParticle {
     private int count = 0;
     private final int vao;
     private final int vbo;
+    private final int vboMesh;
 
     private int color;
     private byte lightIndex;
@@ -34,18 +35,29 @@ public class TessellatorParticleShader implements TessellatorParticle {
         this.buffer = BufferUtils.createByteBuffer(size);
         this.vao = GL41.glGenVertexArrays();
         this.vbo = GL41.glGenBuffers();
+        this.vboMesh = GL41.glGenBuffers();
 
         GL41.glBindVertexArray(this.vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vboMesh);
+        float[] mesh = {
+            -1,  1,
+            -1, -1,
+             1,  1,
+             1, -1,
+        };
+        GL41.glBufferData(GL41.GL_ARRAY_BUFFER, mesh, GL41.GL_STATIC_DRAW);
+        GL41.glVertexAttribPointer(0, 2, GL41.GL_FLOAT, false, 0, 0);
+
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
 
         int offset = 0;
         int vertexSize = 37;
-        GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
-        GL41.glVertexAttribPointer(1, 1, GL41.GL_FLOAT, false, vertexSize, offset); offset += Float.BYTES;        // Scale
-        GL41.glVertexAttribPointer(2, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset);  offset += 4;          // Color
-        GL41.glVertexAttribPointer(3, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
-        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UVSizes
-        GL41.glVertexAttribPointer(5, 1, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 1;           // Lightmap
+        GL41.glVertexAttribPointer(1, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
+        GL41.glVertexAttribPointer(2, 1, GL41.GL_FLOAT, false, vertexSize, offset); offset += Float.BYTES;        // Scale
+        GL41.glVertexAttribPointer(3, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset);  offset += 4;          // Color
+        GL41.glVertexAttribPointer(4, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
+        GL41.glVertexAttribPointer(5, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UVSizes
+        GL41.glVertexAttribPointer(6, 1, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 1;          // Lightmap
 
         GL41.glEnableVertexAttribArray(0);
         GL41.glEnableVertexAttribArray(1);
@@ -53,6 +65,15 @@ public class TessellatorParticleShader implements TessellatorParticle {
         GL41.glEnableVertexAttribArray(3);
         GL41.glEnableVertexAttribArray(4);
         GL41.glEnableVertexAttribArray(5);
+        GL41.glEnableVertexAttribArray(6);
+
+        GL41.glVertexAttribDivisor(0, 0); // Vertices, always reuse the same 4 vertices
+        GL41.glVertexAttribDivisor(1, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(2, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(3, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(4, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(5, 1); // Data, one per quad
+        GL41.glVertexAttribDivisor(6, 1); // Data, one per quad
 
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
         GL41.glBindVertexArray(0);
@@ -108,7 +129,13 @@ public class TessellatorParticleShader implements TessellatorParticle {
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
         GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.buffer.flip(), GL41.GL_STREAM_DRAW);
 
-        GLRenderer.render(this.vao, this.vbo, 0, this.count, DrawMode.POINTS);
+        GLRenderer.getShader().bind();
+        GLRenderer.globalSetUniforms(GLRenderer.getShader());
+
+        GL41.glDrawArraysInstanced(DrawMode.TRIANGLE_STRIP.cap, 0, 4, this.count);
+
+        GL41.glUseProgram(0);
+        GL41.glBindVertexArray(0);
     }
 
     public void checkIsDrawing() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index 3fb385560..40d2af336 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -39,6 +39,10 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         BLOCK_SKIN_MAP.put(Blocks.STATUE_GRANITE_LOWER, basePath + "granite.png");
         BLOCK_SKIN_MAP.put(Blocks.STATUE_MARBLE_LOWER, basePath + "marble.png");
         BLOCK_SKIN_MAP.put(Blocks.STATUE_PIGMAN_LOWER, basePath + "pigman.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_SLATE_LOWER, basePath + "slate.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_PERMAFROST_LOWER, basePath + "permafrost.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_NETHERRACK_LOWER, basePath + "netherrack.png");
+        BLOCK_SKIN_MAP.put(Blocks.STATUE_GLOOMSTONE_LOWER, basePath + "gloomstone.png");
     }
 
     public TileEntityRendererStatue() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index f0115da51..da00230c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -68,7 +68,7 @@ public class WorldTypeFXNether extends WorldTypeFX {
             }
         }
         if (localBiome == Biomes.NETHER_VOLCANIC_ISLANDS) {
-            final int radius = 24;
+            int radius = 24;
             for (int i = 0; i < 2; i++) {
                 double rx = (player.x - radius) + (world.rand.nextDouble() * radius * 2);
                 double ry = (player.y - radius) + (world.rand.nextDouble() * radius * 2);
@@ -78,6 +78,15 @@ public class WorldTypeFXNether extends WorldTypeFX {
                     world.spawnParticle("flame", rx, ry, rz, 0, 0, 0, 0, false);
                 }
             }
+            radius = 12;
+            for (int i = 0; i < 3; ++i) {
+                double rx = player.x - (double) radius + world.rand.nextDouble() * (double) radius * 2.0F;
+                double ry = player.y - (double) radius + world.rand.nextDouble() * (double) radius * 2.0F;
+                double rz = player.z - (double) radius + world.rand.nextDouble() * (double) radius * 2.0F;
+                if (world.getBlockType(tilePos.set(MathHelper.floor(rx), MathHelper.floor(ry), MathHelper.floor(rz))) == Blocks.AIR) {
+                    world.spawnParticle("ashmote", rx, ry, rz, 0.0F, 0.0F, 0.0F, 0, false);
+                }
+            }
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index c2bc17f4a..a6b3f34af 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -173,4 +173,9 @@ public class WorldClient extends World {
     public int renderDistance() {
         return GameSettings.RENDER_DISTANCE.value;
     }
+
+    @Override
+    public int getParticleRenderDistance() {
+        return GameSettings.PARTICLE_RENDER_DISTANCE.value;
+    }
 }
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/ember.emiss.png.mcmeta
similarity index 54%
rename from game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta
rename to game/client/src/main/resources/assets/minecraft/textures/block/ember.emiss.png.mcmeta
index af30dc0cf..57a968853 100644
--- a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block_pure.png.mcmeta
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/ember.emiss.png.mcmeta
@@ -1,6 +1,7 @@
 {
   "animation": {
     "interpolate": true,
-    "frametime": 16
+    "random": true,
+    "frametime": 3
   }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/ember.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/ember.png.mcmeta
new file mode 100644
index 000000000..57a968853
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/ember.png.mcmeta
@@ -0,0 +1,7 @@
+{
+  "animation": {
+    "interpolate": true,
+    "random": true,
+    "frametime": 3
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.emiss.png.mcmeta
new file mode 100644
index 000000000..8dabee5ed
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.emiss.png.mcmeta
@@ -0,0 +1,24 @@
+{
+  "animation": {
+    "interpolate": false,
+    "random": false,
+    "frametime": 7,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7,
+      8,
+      9,
+      10,
+      11,
+      12,
+      13,
+      14
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.png.mcmeta
new file mode 100644
index 000000000..8dabee5ed
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/flowing.png.mcmeta
@@ -0,0 +1,24 @@
+{
+  "animation": {
+    "interpolate": false,
+    "random": false,
+    "frametime": 7,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7,
+      8,
+      9,
+      10,
+      11,
+      12,
+      13,
+      14
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.emiss.png.mcmeta
new file mode 100644
index 000000000..9d8c68748
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.emiss.png.mcmeta
@@ -0,0 +1,12 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 20,
+    "frames": [
+      0,
+      1,
+      2,
+      3
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.png.mcmeta
new file mode 100644
index 000000000..9d8c68748
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/fluid/acid/still.png.mcmeta
@@ -0,0 +1,12 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 20,
+    "frames": [
+      0,
+      1,
+      2,
+      3
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta
new file mode 100644
index 000000000..b13a44198
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.emiss.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.png.mcmeta
new file mode 100644
index 000000000..b13a44198
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/block.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.emiss.png.mcmeta
new file mode 100644
index 000000000..b13a44198
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.emiss.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.png.mcmeta
new file mode 100644
index 000000000..b13a44198
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/brick.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.emiss.png.mcmeta
new file mode 100644
index 000000000..b13a44198
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.emiss.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta
index af30dc0cf..b13a44198 100644
--- a/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta
+++ b/game/client/src/main/resources/assets/minecraft/textures/block/rubyglass/node.png.mcmeta
@@ -1,6 +1,16 @@
 {
   "animation": {
     "interpolate": true,
-    "frametime": 16
+    "frametime": 16,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
   }
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.emiss.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.emiss.png.mcmeta
new file mode 100644
index 000000000..7f7bda9f6
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.emiss.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 4,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.png.mcmeta b/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.png.mcmeta
new file mode 100644
index 000000000..7f7bda9f6
--- /dev/null
+++ b/game/client/src/main/resources/assets/minecraft/textures/item/rubyglass.png.mcmeta
@@ -0,0 +1,16 @@
+{
+  "animation": {
+    "interpolate": true,
+    "frametime": 4,
+    "frames": [
+      0,
+      1,
+      2,
+      3,
+      4,
+      5,
+      6,
+      7
+    ]
+  }
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/acid_overlay.fsh b/game/client/src/main/resources/shaders/acid_overlay.fsh
new file mode 100644
index 000000000..adc932444
--- /dev/null
+++ b/game/client/src/main/resources/shaders/acid_overlay.fsh
@@ -0,0 +1,64 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+
+uniform float uCurrentTick;
+uniform vec4  uColor;
+uniform float uAlphaTest;
+uniform vec2  uViewPortSize;
+
+void main() {
+    // Vignette
+    vec2 centerCoords = TexCoord - 0.5;
+    float dist = length(centerCoords);
+
+    float minVignette = 0.04;
+    float vignetteRamp = smoothstep(0.25, 0.6, dist) * 0.6;
+    float vignetteAlpha = minVignette + vignetteRamp;
+
+    // Droplets
+    float pixelScale = 8.0;
+    vec2 dropUV = floor(TexCoord * (uViewPortSize / pixelScale)) / (uViewPortSize / pixelScale);
+
+    float cols = floor(uViewPortSize.x / 24.0);
+    float streamIndex = floor(dropUV.x * cols);
+    float localX = fract(dropUV.x * cols) - 0.5;
+    float r1 = fract(sin(dot(vec2(streamIndex), vec2(12.9898, 78.233))) * 43758.5453);
+    float r2 = fract(sin(dot(vec2(streamIndex), vec2(39.346, 14.653))) * 28412.123);
+    float speed = 0.3 + 0.3 * r1;
+
+    float rawY = fract(dropUV.y - 0.003 * uCurrentTick * speed + r2);
+    float dropHeight = 0.06 + 0.06 * r2;
+    float t = (rawY - (0.5 - dropHeight * 0.5)) / dropHeight;
+
+    float drop = 0.0;
+    float core = 0.0;
+
+    if (t > 0.0 && t < 1.0) {
+        float distX = abs(localX);
+        float w = 0.0;
+
+        if (t > 0.25 && t < 0.75) {
+            w = 0.3;
+
+            core = step(distX, 0.15);
+        } else if (t > 0.1 && t <= 0.9) {
+            w = 0.15;
+        }
+        drop = step(distX, w);
+    }
+
+    // Colors
+    vec3 baseColor = vec3(0.85, 1.0, 0.25);
+    vec3 dripOuter = vec3(0.65, 0.85, 0.15);
+    vec3 dripInner = vec3(0.95, 1.0, 0.25);
+    vec3 dropCol = mix(dripOuter, dripInner, core);
+    vec3 col = mix(baseColor, dropCol, drop);
+    float distSq = dot(centerCoords, centerCoords);
+    float dripAlpha = 0.08 * drop * (1.0 + distSq * 2.0);
+    float finalAlpha = uColor.a * (vignetteAlpha + dripAlpha);
+    FragColor = vec4(col, finalAlpha);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/acid_overlay.vsh b/game/client/src/main/resources/shaders/acid_overlay.vsh
new file mode 100644
index 000000000..775ecf1e5
--- /dev/null
+++ b/game/client/src/main/resources/shaders/acid_overlay.vsh
@@ -0,0 +1,21 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+
+out vec4 Color;
+out vec2 TexCoord;
+
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+void main() {
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
+    Color = aColor;
+    TexCoord = aUV;
+}
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
index 12aa80801..c34eccbe3 100644
--- a/game/client/src/main/resources/shaders/font.vsh
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -1,18 +1,35 @@
 #version 410 core
-layout (location = 0) in vec2 aPos;
-layout (location = 1) in vec2 aSize;
-layout (location = 2) in vec4 aColor;
-layout (location = 3) in vec2 aUV;
-layout (location = 4) in float aConfig;
-layout (location = 5) in float aLightmap;
-
-out VS_OUT {
-    vec2 size;
-    vec4 color;
-    vec2 uv;
-    vec2 lightmap;
-    float config;
-} vs_out;
+
+#define MASK_ITALIC 0x01u
+#define MASK_UNDERLINE 0x02u
+#define MASK_STRIKETHROUGH 0x04u
+#define MASK_BOLD 0x08u
+#define MASK_OBFUSCATED 0x10u
+#define MASK_OUTLINE 0x20u
+#define MASK_SHADOW 0x80u
+
+layout (location = 0) in vec2 aMesh;
+layout (location = 1) in vec2 aPos;
+layout (location = 2) in vec2 aSize;
+layout (location = 3) in vec4 aColor;
+layout (location = 4) in vec2 aUV;
+layout (location = 5) in float aConfig;
+layout (location = 6) in float aLightmap;
+
+out vec4 Color;
+out vec2 UV;
+out vec2 TexCoord;
+out vec2 Lightmap;
+out vec2 Size;
+out float Config;
+
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 uniform float uZ;
 
@@ -22,11 +39,29 @@ vec2 unpackLightCoord() {
 }
 
 void main() {
-    gl_Position = vec4(aPos, uZ, 1);
+    vec2 bSize = aSize/2;
+    vec4 bColor = aColor;
+    vec2 bUV = aUV/256.0;
+    vec2 bLightmap = unpackLightCoord();
+    float bConfig = aConfig;
+
+    UV = bUV;
+    Size = bSize;
+    Config = bConfig;
+    Color = bColor;
+    Lightmap = bLightmap;
+
+    // x, y, shiftx, exX, exY, exU, exV
+//    0, 1, -1, -1,  2, -1,  2
+//    1, 1, -1,  2,  2,  2,  2
+//    0, 0,  1, -1, -1, -1, -1
+//    1, 0,  1,  2, -1,  2, -1
+
+    // shiftx, exX, and exY are are derivable from the mesh vertices so are not encoded seperately in the static mesh
+    float shiftX = ((aMesh.y * -2) + 1);
+    vec2 ex = (aMesh * 3) - vec2(1, 1);
 
-    vs_out.size = aSize/2;
-    vs_out.color = aColor;
-    vs_out.uv = aUV/256.0;
-    vs_out.lightmap = unpackLightCoord();
-    vs_out.config = aConfig;
+    vec2 shift = vec2((uint(bConfig) & MASK_ITALIC) * shiftX + 8/256, 0);
+    TexCoord = bUV + ((aMesh * aSize + ex)/128);
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos + aSize * aMesh + ex + shift, uZ, 1);
 }
diff --git a/game/client/src/main/resources/shaders/particle.vsh b/game/client/src/main/resources/shaders/particle.vsh
index a23f94354..8e00c2704 100644
--- a/game/client/src/main/resources/shaders/particle.vsh
+++ b/game/client/src/main/resources/shaders/particle.vsh
@@ -1,18 +1,23 @@
 #version 330 core
-layout (location = 0) in vec3 aPos;
-layout (location = 1) in float aScale;
-layout (location = 2) in vec4 aColor;
-layout (location = 3) in vec2 aUv;
-layout (location = 4) in vec2 aUvSizes;
-layout (location = 5) in float aLightmap;
+layout (location = 0) in vec2 aMesh;
+layout (location = 1) in vec3 aPos;
+layout (location = 2) in float aScale;
+layout (location = 3) in vec4 aColor;
+layout (location = 4) in vec2 aUv;
+layout (location = 5) in vec2 aUvSizes;
+layout (location = 6) in float aLightmap;
 
-out VS_OUT {
-    float scale;
-    vec4 color;
-    vec2 uv;
-    vec2 uvSizes;
-    vec2 lightmap;
-} vs_out;
+uniform mat4 model;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
 
 vec2 unpackLightCoord() {
     int asInt = int(aLightmap);
@@ -20,11 +25,9 @@ vec2 unpackLightCoord() {
 }
 
 void main() {
-    gl_Position = vec4(aPos, 1);
+    Color = aColor;
+    LightMapCoord = unpackLightCoord();
 
-    vs_out.scale = aScale;
-    vs_out.color = aColor;
-    vs_out.uv = aUv;
-    vs_out.uvSizes = aUvSizes;
-    vs_out.lightmap = unpackLightCoord();
+    TexCoord = aUv + (((aMesh * vec2(1, -1)) + vec2(1, 1))/2.0) * aUvSizes;
+    gl_Position = matrices.projection * matrices.view * model * (vec4(aPos, 1) + matrices.viewInv * vec4(aMesh.x,  aMesh.y, 0.0, 1.0) * aScale);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index 1fa32fe63..9e05ec69e 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -149,6 +149,13 @@ public abstract class Achievements
         new Achievement(NamespaceID.fromPool("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
+    public static final Achievement GET_STEEL_BLAST_FURNACE =
+        new Achievement(NamespaceID.fromPool("minecraft", "blast_furnace"), "blastFurnace", Blocks.FURNACE_BLAST_ACTIVE, Achievements.GET_NETHERCOAL)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement();
+    public static final Achievement OBTAIN_STEEL =
+        new Achievement(NamespaceID.fromPool("minecraft", "obtain_steel"), "obtainSteel", Items.INGOT_STEEL, GET_STEEL_BLAST_FURNACE)
+            .registerAchievement();
 
     public static void init(){};
 }
